 /**
******************************************************************************
* @file    			tcp_demo.c                                                   *
* @author  			WisIOE Software Team                                         *
* @version 			V1.2																												 *		
* @date    			2017-11-01																								   *
* @brief 			  TCP ʾ     												                     *					
******************************************************************************
* @company  		Ƽ޹˾                                         	 *
* @website  		www.wisioe.com																							 *	 				
* @forum        www.w5500.cn																								 *		
* @qqGroup      383035001																										 * 
******************************************************************************
*/ 
#include <stdio.h>
#include <string.h>
#include "tcp_demo.h"
#include "W5500_conf.h"
#include "w5500.h"
#include "socket.h"

uint8 buff[2048];				                              	         /*һ2KBĻ*/

/**
*@brief		TCP Serverػʾ
*@param		
*@return	
*/
void do_tcp_server(void)
{
	uint16 len=0;
	
	switch(getSn_SR(SOCK_TCPS))											            	/*ȡsocket״̬*/
	{
		case SOCK_CLOSED:													                  /*socketڹر״̬*/
			socket(SOCK_TCPS ,Sn_MR_TCP,local_port,Sn_MR_ND);	        /*socket*/
		  break;     
    
		case SOCK_INIT:														                  /*socketѳʼ״̬*/
			listen(SOCK_TCPS);												                /*socket*/
		  break;
		
		case SOCK_ESTABLISHED:												              /*socketӽ״̬*/
			if(getSn_IR(SOCK_TCPS) & Sn_IR_CON)
			{
				setSn_IR(SOCK_TCPS, Sn_IR_CON);								          /*жϱ־λ*/
			}
			len=getSn_RX_RSR(SOCK_TCPS);									            /*lenΪѽݵĳ*/
			if(len>0)
			{
				recv(SOCK_TCPS,buff,len);								              	/*Client*/
				buff[len]=0x00; 											                  /*ַ*/
				printf("%s\r\n",buff);
				send(SOCK_TCPS,buff,len);									              /*Client*/
		  }
		  break;
		
		case SOCK_CLOSE_WAIT:												                /*socketڵȴر״̬*/
			close(SOCK_TCPS);
		  break;
	}
}

/**
*@brief		TCP Clientػʾ
*@param		
*@return	
*/
void do_tcp_client(void)
{	
   uint16 len=0;	

	switch(getSn_SR(SOCK_TCPC))								  				         /*ȡsocket״̬*/
	{
		case SOCK_CLOSED:											        		         /*socketڹر״̬*/
			socket(SOCK_TCPC,Sn_MR_TCP,local_port++,Sn_MR_ND);
		  break;
		
		case SOCK_INIT:													        	         /*socketڳʼ״̬*/
			connect(SOCK_TCPC,remote_ip,remote_port);                /*socketӷ*/ 
		  break;
		
		case SOCK_ESTABLISHED: 												             /*socketӽ״̬*/
			if(getSn_IR(SOCK_TCPC) & Sn_IR_CON)
			{
				setSn_IR(SOCK_TCPC, Sn_IR_CON); 							         /*жϱ־λ*/
			}
			len=getSn_RX_RSR(SOCK_TCPC); 								  	         /*lenΪѽݵĳ*/
			if(len>0)
			{
		    printf("len = %d\r\n",len);
				recv(SOCK_TCPC,buff,len); 							   		         /*Server*/
				buff[len]=0x00;  											                 /*ַ*/
				printf("%s\r\n",buff);
				send(SOCK_TCPC,buff,len);								     	         /*Server*/
			}		  
		  break;
			
		case SOCK_CLOSE_WAIT: 											    	         /*socketڵȴر״̬*/
			close(SOCK_TCPC);
		  break;
	}
}

