#include "sys.h"
#include "delay.h"
#include "uart.h"
#include "bsp_i2c_ee.h"
#include "bsp_i2c_gpio.h"
#include "w5500.h"
#include "W5500_conf.h"
#include "socket.h"
#include "tcp_demo.h"
	
/********************************************************************************************************
**Ϣ int main (void)                          
** 󣬴ִӡ256ҳ
** 
** 
********************************************************************************************************/
int main(void)
{
  delay_init();	    	          	//ʱʼ	  
  uart_initwBaudRate(115200);	 		//ڳʼΪ115200
	i2c_CfgGpio();				    	    //ʼeeprom
	
	gpio_for_w5500_config();	       //ʼMCU
	reset_w5500();					         //ӲλW5500
	PHY_check();                     //Ƿ 
	set_w5500_mac();                 //MACַ
	set_w5500_ip();                  //IPַ
	
	socket_buf_init(txsize, rxsize); //ʼ8SocketķͽջС
	
	printf(" ΪTCP,W5500Ϊ TCPͻȥ \r\n");
	printf(" IP:%d.%d.%d.%d\r\n",remote_ip[0],remote_ip[1],remote_ip[2],remote_ip[3]);
	printf(" ˿:%d \r\n",remote_port);
	printf(" ӳɹ󣬷ݸW5500W5500ضӦ \r\n");
	printf(" ӦóִС\r\n"); 
	
  while(1)
  {
		do_tcp_client();               //TCP_Client ݻػԳ
  }
}

